
# Network Controller GUI development setup

## Initial Setup

These instructions have been tested on Windows 10 OS.

1. Install Node.js v12.14 from

    [https://nodejs.org/en/](Node.js)

This process worked OK with Node.js 12.16.2 LTS

2. Install npm dependencies.<br>
From directory containing this README.md file run the following command:   

```
    npm install
```

3. Link PT_Netcon Client SDK to this client.
From the Network Controller SDK directory located at "packettracer\engine\algorithms\netcon\swagger\generated\netcon-js-client\\", run the following commands:

```
    npm install
    npm link
```

From directory containing this README.md file run the following command:

```
    npm link "cisco_packet_tracer_northbound_api_for_network_controller_device"
```

4. Configure webpack configuration. 
Inside directory containing this README.md file run the following command:

```
    copy /Y .\scripts\webpack.config.js .\node_modules\react-scripts\config\webpack.config.js
```

## Available Scripts

Inside directory containing this README.md file you can run:
<br/>

```
    npm start
```
Runs the app in the development mode.<br />
Open [http://localhost:3000](http://localhost:3000) to view it in the browser.

The page will reload if you make edits.<br/>
You will also see any lint errors in the console.<br/>
<br/>

```
    npm run build
```
Builds the app for production to the `build` folder.<br />
It correctly bundles React in production mode and optimizes the build for the best performance.

The build is minified and the filenames include the hashes.<br />
Your app is ready to be deployed!

## Gotchas:

1. If chrome complains about CORS, add the following flags when opening the browser
```
    chrome.exe --disable-web-security --user-data-dir="c:/packettracer"
```
2. Firefox produces a CORS error and does not seem to allow a workaround similar to the above for Chrome. 
3. In order to see the UI page start Packet Tracer and load netcon.pkt sample file. <br/>
Alternatively you can just add Network Controller device to empty workspace and make sure it has initial admin user account setup on it. After this you should be able to see the login of the controller in your external browser. 

## References: 

* Get latest PT73 build from http://engci-maven-master.cisco.com/artifactory/netacad-beta/PacketTracer/ptna/

* Examples using Curl - https://confluence.netacad.net/confluence/display/home/PTNA+MILESTONE+2+DELIVERABLE

* PTNA test bed access - https://confluence.netacad.net/confluence/display/home/PTNA+Test+Bed+Access

* Swagger generated Client SDK location - packettracer\engine\algorithms\netcon\swagger\generated\netcon-js-client\src

