//---------------------------------------------------------------------------//
// Import
//---------------------------------------------------------------------------//

import PT from '../PT';
import Util from '../utils';

//---------------------------------------------------------------------------//

const assuranceApi = new PT.Netcon_Sdk.AssuranceApi();

const getNetworkHealth = (dispatch) => {
    assuranceApi.getNetworkHealth((err, item, res) => {
        Util.responseHandler(err, item, res, dispatch, ()=>{
            let result = JSON.parse(res.text).response;
            if(result){
                dispatch({
                    type: 'ASSURANCE_SET_NETWORK_HEALTH',
                    payload: {
                        networkHealth: result
                    }
                });
            }
        });
    });
};

const getAllNetworkIssues = (dispatch) => {
    assuranceApi.getAllNetworkIssues((err, item, res) => {
        Util.responseHandler(err, item, res, dispatch, ()=>{
            let result = JSON.parse(res.text).response;
            if(result){
                dispatch({
                    type: 'ASSURANCE_SET_NETWORK_ISSUES',
                    payload: {
                        allNetworkIssues: result
                    }
                });
            }
        });
    });
};

const getNetworkIssue = (dispatch, id) => {
    assuranceApi.getNetworkIssue(id, (err, item, res) => {
        Util.responseHandler(err, item, res, dispatch, ()=>{
            let result = JSON.parse(res.text).response;
            if(result){
                console.log(result)
            }
        });
    });
};

//---------------------------------------------------------------------------//
// Export
//---------------------------------------------------------------------------//

export default { 
    getNetworkHealth, 
    getAllNetworkIssues, 
    getNetworkIssue 
};

//---------------------------------------------------------------------------//