//---------------------------------------------------------------------------//
// Import
//---------------------------------------------------------------------------//

import PT from '../PT';
import _ from 'lodash';
import Util from '../utils';

//---------------------------------------------------------------------------//

const globalCredentialApi = new PT.Netcon_Sdk.GlobalCredentialApi();

const getCliCredential = (dispatch) => {
    globalCredentialApi.getCliCredential((err, item, res) => {
        Util.responseHandler(err, item, res, dispatch, ()=>{
            let result = JSON.parse(res.text);
            if(result){
                if(result.response===undefined || _.isEmpty(result)){
                    result=[];
                }else{
                    result = result.response;
                }

                dispatch({
                    type: 'CLIS_FETCH',
                    payload: {
                        list: result
                    }
                });
            }
        });
    });
};

const addCliCredential = (dispatch, credential) => {
    globalCredentialApi.addCliCredential(credential, (err, item, res) => {
        Util.responseHandler(err, item, res, dispatch, ()=>{
            let result = JSON.parse(res.text);
            if(result){
                getCliCredential(dispatch);
            }
        });
    });
};

const deleteGlobalCredential = (dispatch, id) => {
    globalCredentialApi.deleteGlobalCredential(id, (err, item, res) => {
        Util.responseHandler(err, item, res, dispatch, ()=>{
            let result = JSON.parse(res.text);
            if(result){
                getCliCredential(dispatch);
            }
        });
    });
};

//---------------------------------------------------------------------------//
// Export
//---------------------------------------------------------------------------//

export default {  
    getCliCredential, 
    addCliCredential, 
    deleteGlobalCredential 
};

//---------------------------------------------------------------------------//