//---------------------------------------------------------------------------//
// Import
//---------------------------------------------------------------------------//

import PT from '../PT';
import Util from '../utils';
import _ from 'lodash';

//---------------------------------------------------------------------------//

const hostApi = new PT.Netcon_Sdk.HostOperationApi();

const getHosts = (dispatch) => {
    hostApi.getHosts({}, (err, item, res) => {
        Util.responseHandler(err, item, res, dispatch, ()=>{
            let result = JSON.parse(res.text);
            let list = [];
            if(_.isUndefined(result.response)){
                list = [];
            }else{
                list = result.response;
            }
            dispatch({
                type: 'HOSTS_FETCH',
                payload: {
                    list: list
                }
            });
        });
    });
};

const deleteHostByIp = (dispatch, ip) => {

    hostApi.deleteHostByIp(ip, (err, item, res) => {
        Util.responseHandler(err, item, res, dispatch, ()=>{
            getHosts(dispatch);
        });
    });
};

//---------------------------------------------------------------------------//
// Export
//---------------------------------------------------------------------------//

export default { 
    getHosts, 
    deleteHostByIp
};

//---------------------------------------------------------------------------//