//---------------------------------------------------------------------------//
// Import
//---------------------------------------------------------------------------//

import PT from '../PT';
import Toast from '../components/Toast';
import Util from '../utils';

//---------------------------------------------------------------------------//

const settingsApi = new PT.Netcon_Sdk.NetworkWideSettingApi();

const getNetworkWideSetting = (dispatch, fetchCallback) => {
    settingsApi.getNetworkWideSetting((err, item, res) => {
        Util.responseHandler(err, item, res, dispatch, ()=>{
            let result = JSON.parse(res.text);
            if(Object.keys(result).length){
                dispatch({
                    type: 'SETTINGS_FETCH',
                    payload: {
                        settings: result.response
                    }
                });
                fetchCallback();
            }
        });
    });
};

const updateNetworkWideSetting = (dispatch, settings) => {

    let payload = {
        'networkWideSetting': {...settings }
    }

    settingsApi.updateNetworkWideSetting(payload, (err, item, res) => {
        Util.responseHandler(err, item, res, dispatch, ()=>{
            let result = JSON.parse(res.text);
            if(result){
                dispatch({
                    type: 'SETTINGS_FETCH',
                    payload: {
                        settings: settings
                    }
                });
                Toast.success('Saved Successfully');
            }
        });
    });
};

//---------------------------------------------------------------------------//
// Export
//---------------------------------------------------------------------------//

export default { 
    getNetworkWideSetting,
    updateNetworkWideSetting 
};

//---------------------------------------------------------------------------//