//---------------------------------------------------------------------------//
// Import
//---------------------------------------------------------------------------//

import PT from '../PT';
import Toast from '../components/Toast';
import Util from '../utils';

//---------------------------------------------------------------------------//

const userApi = new PT.Netcon_Sdk.UserApi();

const getUsers = (dispatch) => {
    userApi.getUsers((err, item, res) => {
        Util.responseHandler(err, item, res, dispatch, ()=>{
            let list = JSON.parse(res.text).response;
            if(list){
                dispatch({
                    type: 'USERS_FETCH',
                    payload: {
                        list: list
                    }
                });
            }
        });
    });
};

const updateUser = (dispatch, user) => {
    let payload = {
        'user': {...user }
    }
    userApi.updateUser(payload, (err, item, res) => {
        Util.responseHandler(err, item, res, dispatch, ()=>{
            let result = JSON.parse(res.text);
            if(result){
                getUsers(dispatch);
                Toast.success('Saved Successfully');
            }
        });
    });
};

//---------------------------------------------------------------------------//
// Export
//---------------------------------------------------------------------------//

export default { 
    getUsers, 
    updateUser
};

//---------------------------------------------------------------------------//