//---------------------------------------------------------------------------//
// Import
//---------------------------------------------------------------------------//

import Netcon_Sdk from 'cisco_packet_tracer_northbound_api_for_network_controller_device';

//---------------------------------------------------------------------------//

const default_port = 58699;
const defaultClient = Netcon_Sdk.ApiClient.instance;

let url = '';

if(process.env.NODE_ENV==='development'){
    url = `http://localhost:${default_port}/netcon/api/v1`;
}else{
    url = `http://${window.location.host}/api/v1`;
}

const setAuthTokenHeader = (token) => {
    defaultClient.defaultHeaders['X-Auth-Token']= token;
};

const getApiKey = () => {
    let result = window.sessionStorage.getItem('apiKey')
    if(result===null){
        return ''
    }else{
        return result;
    }
};

const setApiKey = (apiKey) => {
    window.sessionStorage.setItem('apiKey', apiKey);
};

const setUsername = (username) => {
    window.sessionStorage.setItem('username', username);
};

const getUsername = () => {
    let result = window.sessionStorage.getItem('username')
    if(result===null){
        return ''
    }else{
        return result;
    }
};

const setPort = (port) => {
    defaultClient.basePath = url;
};

const setUser = (username, apiKey) => {
    setUsername(username);
    setApiKey(apiKey);
};

const clearUser = () => {
    window.sessionStorage.removeItem('apiKey');
    window.sessionStorage.removeItem('username');
};

const clearAuthTokenHeader = () => {
    setAuthTokenHeader('');
};

// Set initial values onload.

setPort(default_port);
setAuthTokenHeader(window.sessionStorage.getItem('apiKey'));
setUsername(window.sessionStorage.getItem('username'));

//---------------------------------------------------------------------------//
// Export
//---------------------------------------------------------------------------//

export default { 
    Netcon_Sdk, 
    setPort, 
    setAuthTokenHeader, 
    setUsername, 
    setApiKey, 
    setUser,
    clearUser,
    getApiKey,
    getUsername,
    clearAuthTokenHeader
};

//---------------------------------------------------------------------------//