//---------------------------------------------------------------------------//
// Import
//---------------------------------------------------------------------------//

import { createMuiTheme } from "@material-ui/core/styles";

//---------------------------------------------------------------------------//

const theme = createMuiTheme({
    overrides:{
        MuiAppBar:{
            root: {
                marginBottom: 15
            },
            colorPrimary:{
                backgroundColor: '#1E4471',
            }
        },
        MuiGrid:{
            item:{
                width:'100%'
            }
        },
        MuiCard:{
            root:{
                overflow:'auto'
            }
        },
        MuiButton:{
            outlinedSecondary:{
                color: 'black'
            },
            containedPrimary:{
                backgroundColor: '#1e4471',
                "&:hover": {
                    backgroundColor: "#0d274d"
                }
            },
            containedSecondary:{
                backgroundColor: '#525659',
                "&:hover": {
                    backgroundColor: "#282C30"
                }
            }
        },
        MuiTableRow:{
            root: {  
                "&$selected":{ 
                    backgroundColor: '#dee2e6',
                    "&:hover":{
                        backgroundColor: "#dee2e6"
                    }
                }
            }
        }
    }
});

//---------------------------------------------------------------------------//
// Export
//---------------------------------------------------------------------------//

export default theme;

//---------------------------------------------------------------------------//