
const initialState = {
    apiKey: '',
    username: '',
    setupCompleted: null
};

const reducer = (state = initialState, action) => {

    const newState = {...state}

    switch (action.type) {

        case 'APP_SET_SETUPCOMPLETED': {
            return {
                ...state,
                setupCompleted: action.payload.setupCompleted
            }
        }
        
        case 'APP_SET_APIKEY': {
            return {
                ...state,
                apiKey: action.payload.apiKey
            }
        }

        case 'APP_SET_USERNAME': {
            return {
                ...state,
                username: action.payload.username
            }
        }
        
        case 'APP_SET_STATE': {
            return {
                ...state, 
                ...action.payload
            }
        }

        case 'APP_LOGOUT': {
            return {
                ...state,
                apiKey: '',
                username: ''
            }
        }

        default: {
            break;
        }
    }
    return newState;
};

export default reducer;
