
const initialState = {
    list: [],
    detail: {},
    discoveredDevices: [],
    selectedId: ''
};

const reducer = (state = initialState, action) => {

    switch (action.type) {

        case 'DISCOVERY_FETCH_ALL': {
            return {
                ...state, 
                list: action.payload.list
            };
        }

        case 'DISCOVERY_SET_SELECTED': {
            return {
                ...state, 
                selectedId: action.payload.id
            };
        }

        case 'DISCOVERY_DETAIL': {
            return {
                ...state, 
                detail: action.payload.detail
            };
        }
        
        case 'DISCOVERY_DISCOVERED_DEVICES': {
            return {
                ...state, 
                discoveredDevices: action.payload.list
            };
        }

        case 'DISCOVERY_STOP': {
            let detail = { 
                ...state.detail,
                discoveryCondition: 'Incomplete',
                discoveryStatus: 'Stopped',
            }
            return {
                ...state, 
                ...detail
            }
        }

        default: {
            return state;
        }
    }
};

export default reducer;
