
const initialState = {
    open: false,
    message: '',
};

const reducer = (state = initialState, action) => {

    switch (action.type) {

        case 'MESSAGE_CLOSE': {
            return {
                ...state, 
                open: false 
            }
        }

        case 'MESSAGE_ERROR': {
            return {
                ...state, 
                open: true,
                message: action.payload.message
            }
        }

        case 'MESSAGE_ERROR_WITH_CODE': {
            
            let message = `${action.payload.code} - ${action.payload.message} - ${action.payload.detail}`;

            return {
                ...state, 
                open: true,
                message: message
            }
        }

        default: {
            return state;
        }
    }
};

export default reducer;
