
const initialState = {
    aaa: {
        ipAddress: '',
        key: ''
    },
    dns:{
        ipAddress: '',
        name: ''
    },
    netflow:{
        port: '',
        reflectionIp: ''
    },
    ntp:{
        serverIp: ''
    },
    syslog: []
};

const reducer = (state = initialState, action) => {

    switch (action.type) {
        
        case 'SETTINGS_FETCH': {

            
            let settings = action.payload.settings;
            let result = {...state};

            result.aaa = {...result.aaa, ...settings.aaa};
            result.dns = {...result.dns, ...settings.dns};
            result.netflow = {...result.netflow, ...settings.netflow};
            result.ntp = {...result.ntp, ...settings.ntp};

            if(settings.syslog){
                result.syslog = [...settings.syslog];
            }

            return result
        }

        case 'SETTINGS_CHANGE': {
            let result = action.payload.settings;
            return {
                ...state, ...result
            }
        }

        default: {
            return state;
        }
    }
};

export default reducer;
