
const initialState = {
    links: [],
    nodes: [],
    detail: {},
    lastUpdated: 0
};

const reducer = (state = initialState, action) => {
    switch (action.type) {

        case 'TOPOLOGY_FETCH': {
            return {
                ...state, 
                ...action.payload.topology
            };
        }

        case 'TOPOLOGY_DETAIL': {
            return {
                ...state, 
                detail: action.payload.detail
            };
        }

        case 'TOPOLOGY_LASTUPDATED': {
            return {
                ...state, 
                lastUpdated: action.payload.time
            };
        }

        default: {
            return state;
        }
    }
};

export default reducer;
