
//---------------------------------------------------------------------------//
// Import
//---------------------------------------------------------------------------//

import PT from '../PT';

//---------------------------------------------------------------------------//

const responseHandler = (err, item, res, dispatch, callback) => {

    if(err){
        if(res && res.statusCode===403){
            PT.clearUser();
            dispatch({
                type: 'APP_LOGOUT'
            })
        }
        let msg = err.toString();
        if(res){
            msg += res.text;
            dispatch({
                type: 'MESSAGE_ERROR',
                payload: {
                    message: msg
                }
            });
        }
    }else{

        let response = JSON.parse(res.text).response;
        if(response && response.errorCode){
            dispatch({
                type: 'MESSAGE_ERROR_WITH_CODE',
                payload: {
                    code: response.errorCode,
                    message: response.message,
                    detail: response.detail
                }
            });
        }else{
            if(callback!==undefined){
                callback();
            }
        }
    }
};

//---------------------------------------------------------------------------//
// Export
//---------------------------------------------------------------------------//

export default responseHandler;

//---------------------------------------------------------------------------//