//---------------------------------------------------------------------------//
// Import
//---------------------------------------------------------------------------//

import React from 'react';
import Item from './Item';
import _ from 'lodash';

//---------------------------------------------------------------------------//
// Component
//---------------------------------------------------------------------------//

const Component = (props) => {
    
    const getNetworkHealthUI = () => {
        if(props.state.assurance.networkHealth.length){
            let latestNetworkHealth = props.state.assurance.networkHealth[props.state.assurance.networkHealth.length-1];
            let result = [];
            let devices = latestNetworkHealth.networkDevices.networkDevices;
            _.forEach(devices, (device, index)=>{
                result.push(
                    <Item 
                        key={index} 
                        {...device} 
                        isLast={false}
                        labels={[
                            'Managed',
                            'Unmanaged'
                        ]}
                    />
                )
            });

            let reachableHost = _.countBy(props.state.hosts, (host)=>{
                return host.pingStatus==='SUCCESS';
            })

            result.push(
                <Item 
                    key={devices.length+1} 
                    isLast={true}
                    healthyPercentage = {latestNetworkHealth.clients.totalPercentage}
                    healthyRatio={`${reachableHost.true?reachableHost.true:0}:${props.state.hosts.length}`}
                    deviceType={'Hosts'}
                    labels={[
                        'Reachable',
                        'Unreachable'
                    ]}
                />
            )

            return result;
        }else{
            return null;
        }
    };

    return getNetworkHealthUI();
};

//---------------------------------------------------------------------------//
// Export
//---------------------------------------------------------------------------//

export default Component;

//---------------------------------------------------------------------------//