//---------------------------------------------------------------------------//
// Import
//---------------------------------------------------------------------------//

import React from 'react';
import Table from '@material-ui/core/Table';
import TableBody from '@material-ui/core/TableBody';
import TableCell from '@material-ui/core/TableCell';
import TableHead from '@material-ui/core/TableHead';
import TableRow from '@material-ui/core/TableRow';
import _ from 'lodash';
import moment from 'moment';

//---------------------------------------------------------------------------//
// Component
//---------------------------------------------------------------------------//

const Component = (props) => {

    const getRows = () => {
        let result = [];
        _.forEach(props.state.assurance.allNetworkIssues, (issue, index)=>{

            result.push(
                <TableRow 
                    key={index}
                    hover={true}
                >
                    <TableCell size='small' id={`assurance-issue-issueTimestamp-${index}`}>{moment(issue.issueTimestamp).format('YYYY-MM-DD HH:MM')}</TableCell>
                    <TableCell size='small' id={`assurance-issue-issueName-${index}`}>{issue.issueName}</TableCell>
                    <TableCell size='small' id={`assurance-issue-issueDescription-${index}`}>{issue.issueDescription}</TableCell>
                    <TableCell size='small' id={`assurance-issue-issueSource-${index}`}>{issue.issueSource}</TableCell>
                </TableRow>
            );
        });
        return result;
    };

    return (
        <Table>
            <TableHead>
                <TableRow>
                    <TableCell align='left' size='small' style={{ fontWeight:'bold'}}>Date</TableCell>
                    <TableCell align='left' size='small' style={{ fontWeight:'bold'}}>Name</TableCell>
                    <TableCell align='left' size='small' style={{ fontWeight:'bold'}}>Description</TableCell>
                    <TableCell align='left' size='small' style={{ fontWeight:'bold'}}>Source</TableCell>
                </TableRow>
            </TableHead>
            <TableBody>
                {getRows()}
            </TableBody>
        </Table>
    );
};

//---------------------------------------------------------------------------//
// Export
//---------------------------------------------------------------------------//

export default Component;

//---------------------------------------------------------------------------//