//---------------------------------------------------------------------------//
// Import
//---------------------------------------------------------------------------//

import React, { useEffect } from 'react';
import Table from '@material-ui/core/Table';
import TableBody from '@material-ui/core/TableBody';
import TableCell from '@material-ui/core/TableCell';
import TableHead from '@material-ui/core/TableHead';
import TableRow from '@material-ui/core/TableRow';
import _ from 'lodash';

import Confirm from './Confirm';

//---------------------------------------------------------------------------//
// Component
//---------------------------------------------------------------------------//

const Component = (props) => {

    useEffect(() => {
        props.dispatchUtil.fetchCliCredentials();
    },[props.dispatchUtil]);

    const rows = () => {

        let rows = [];
        _.forEach(props.state.clis, (item, key) => {
            rows.push(
                <TableRow 
                    key={key}
                    hover={true}
                >
                    <TableCell id={`user-cli-id-${key}`} align='left' size='small'>{item.id}</TableCell>
                    <TableCell id={`user-cli-username-${key}`} align='left' size='small'>{item.username}</TableCell>
                    <TableCell id={`user-cli-description-${key}`} align='left' size='small'>{item.description}</TableCell>
                    <TableCell 
                        align='left' 
                        size='small'
                        padding='checkbox'
                    >
                        <Confirm cli={item} index={key} {...props} />
                    </TableCell>
                </TableRow>
            )
        });
        return rows
    };    
    
    return (
        <Table>
            <TableHead>
                <TableRow>
                    <TableCell align='left' size='small' style={{ fontWeight: 'bold' }}>ID</TableCell>
                    <TableCell align='left' size='small' style={{ fontWeight: 'bold' }}>Username</TableCell>
                    <TableCell align='left' size='small' style={{ fontWeight: 'bold' }}>Description</TableCell>
                    <TableCell align='left' size='small' style={{ fontWeight: 'bold' }}>Action</TableCell>
                </TableRow>
            </TableHead>
            <TableBody>
                { rows() }
            </TableBody>
        </Table>
    );
};

//---------------------------------------------------------------------------//
// Export
//---------------------------------------------------------------------------//

export default Component;

//---------------------------------------------------------------------------//