//---------------------------------------------------------------------------//
// Import
//---------------------------------------------------------------------------//

import React from 'react';
import Button from '@material-ui/core/Button';
import { faTrash } from '@fortawesome/free-solid-svg-icons';
import { library } from '@fortawesome/fontawesome-svg-core';
import Dialog from '@material-ui/core/Dialog';
import DialogActions from '@material-ui/core/DialogActions';
import DialogContent from '@material-ui/core/DialogContent';
import DialogTitle from '@material-ui/core/DialogTitle';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome'

//---------------------------------------------------------------------------//

library.add(faTrash);

//---------------------------------------------------------------------------//
// Component
//---------------------------------------------------------------------------//

const Component = (props) => {

    const [open, setOpen] = React.useState(false);

    const handleClickOpen = () => {
        setOpen(true);
    };

    const handleClose = () => {
        setOpen(false);
    };

    const handleSubmit = () => {
        props.dispatchUtil.removeCliCredential(props.cli.id);
        setOpen(false);
    };
    
    return (
        <>
            <button
                aria-label="Click to delete"
                id={`user-cli-remove-${props.index}`}
                onClick={handleClickOpen}
                style={{
                    width: 35,
                    height: 25,
                    borderRadius: 5
                }}
            >
                <FontAwesomeIcon 
                    icon='trash' 
                    size='1x' 
                    fixedWidth
                    style={{
                        color: 'red'
                    }}
                />
            </button>

            <Dialog open={open} onClose={handleClose} aria-labelledby='Confirmation Dialog'>
                <DialogTitle id='form-dialog-title'>Confirmation</DialogTitle>
                <DialogContent>
                    <span style={{fontSize:18}}>Are you sure you want to delete?</span>
                </DialogContent>
                <DialogActions>
                <Button id='credential-confirm-cancel' onClick={handleClose} color='default'>
                    Cancel
                </Button>
                <Button id='credential-confirm-submit' onClick={handleSubmit} color='primary'>
                    Delete
                </Button>
                </DialogActions>
            </Dialog>
        </>
    );
};

//---------------------------------------------------------------------------//
// Export
//---------------------------------------------------------------------------//

export default Component;

//---------------------------------------------------------------------------//