//---------------------------------------------------------------------------//
// Import
//---------------------------------------------------------------------------//

import React from 'react';
import Card from '@material-ui/core/Card';
import CardHeader from '@material-ui/core/CardHeader';
import CardContent from '@material-ui/core/CardContent';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import { faCog } from '@fortawesome/free-solid-svg-icons';
import { library } from '@fortawesome/fontawesome-svg-core';
import { useHistory } from 'react-router-dom';
import { makeStyles } from '@material-ui/core/styles';
import Content from './Content';

//---------------------------------------------------------------------------//

library.add(faCog);

const useStyles = makeStyles(theme => ({
    card:{
        borderRadius: 10,
        color: 'white'
    },
    title: {
        fontSize: 16,
    },
}));

//---------------------------------------------------------------------------//
// Component
//---------------------------------------------------------------------------//

const Component = (props) => {
    let history = useHistory();
    const classes = useStyles();
    const navigate = () => {
        history.push('assurance');
    };

    return (
        <Card
            className={classes.card}
            style={{
                background: props.background
            }}
        >
            <CardHeader
                title={props.name}
                classes={{
                    title: classes.title
                }}
                style={{
                    paddingBottom: 0
                }}
                action={
                    <button
                        id={`dashboard-assurance-navigate-btn-${props.index}`}
                        onClick={navigate} 
                        style={{
                            cursor:'pointer',
                            width: 40,
                            height: 30,
                            background: 'none',
                            borderRadius: 5,
                            border: '1px white solid',
                            float:'right',
                            margin: 5,
                            
                        }}
                        role='button'
                        aria-label={'assurance details'}
                    >
                        <FontAwesomeIcon 
                            icon='cog'
                            size='lg'
                            style={{
                                color: 'white'
                            }}
                        />
                    </button>
                }
            />
            <CardContent >
                <Content {...props} />
            </CardContent>
        </Card>
    );
};

//---------------------------------------------------------------------------//
// Export
//---------------------------------------------------------------------------//

export default Component;

//---------------------------------------------------------------------------//
