//---------------------------------------------------------------------------//
// Import
//---------------------------------------------------------------------------//

import React from 'react';
import Item from './Item';
import Grid from '@material-ui/core/Grid';
import _ from 'lodash';

//---------------------------------------------------------------------------//

const backgroundColor = '#1E4471';

//---------------------------------------------------------------------------//
// Component
//---------------------------------------------------------------------------//

const Component = (props) => {

    let result = [];
    let clientTotal = 0;
    let clientHealth = 0;
    let clientChartData = [];
    let deviceTotal = 0;
    let deviceHealth = 0;
    let deviceChartData = [];

    if(props.state.assurance.networkHealth.length){

        let latestNetworkHealth = props.state.assurance.networkHealth[props.state.assurance.networkHealth.length-1];

        _.forEach(props.state.assurance.networkHealth, (health)=>{

            clientChartData.push({
                x: new Date(health.timestamp),
                y: health.clients.totalPercentage
            });

            deviceChartData.push({
                x: new Date(health.timestamp),
                y: health.networkDevices.totalPercentage
            });
        });

        clientTotal = latestNetworkHealth.clients.totalPercentage;
        clientHealth = latestNetworkHealth.clients.totalConnected;
        deviceTotal = latestNetworkHealth.networkDevices.totalPercentage;
        deviceHealth = latestNetworkHealth.networkDevices.totalDevices;

    }

    let index = 0;

    result.push(
        <Grid key={index} item lg={4} md={6} style={{width:'100%'}}>
            <Item
                index={index}
                background={backgroundColor}
                name={'Percentage of hosts can be reached via ping'}
                countTitle={'Total Clients'}
                percentage={clientTotal}
                total={clientHealth}
                data={clientChartData}
            />
        </Grid>
    );

    index++;

    result.push(
        <Grid key={index} item lg={4} md={6} style={{width:'100%'}}>
            <Item
                index={index}
                background={backgroundColor} 
                name={'Percentage of network devices that are in Managed state'}
                countTitle={'Total Devices'}
                percentage={deviceTotal}
                total={deviceHealth}
                data={deviceChartData}
            />
        </Grid>
    );

    return result;
};

//---------------------------------------------------------------------------//
// Export
//---------------------------------------------------------------------------//

export default Component;

//---------------------------------------------------------------------------//
