//---------------------------------------------------------------------------//
// Import
//---------------------------------------------------------------------------//

import React from 'react';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import { faServer, faCog } from '@fortawesome/free-solid-svg-icons';
import { library } from '@fortawesome/fontawesome-svg-core';
import { useHistory } from 'react-router-dom';

import Card from '@material-ui/core/Card';
import CardHeader from '@material-ui/core/CardHeader';
import CardContent from '@material-ui/core/CardContent';

import Content from './Content';

//---------------------------------------------------------------------------//

library.add(faServer ,faCog);

//---------------------------------------------------------------------------//
// Component
//---------------------------------------------------------------------------//

const Component = (props) => {
    
    let history = useHistory();

    const navigate = () => {
        history.push('inventory');
    };

    return (
        <Card
            role='contentinfo'
            aria-label='Device inventory'
        >
            <CardHeader
                style={{
                    color:'white',
                    background: '#1e714c'
                }}
                avatar={
                    <FontAwesomeIcon 
                        icon='server' 
                        size='lg' 
                        fixedWidth style={{color:'white'}}
                    />
                }
                title='Network Device'
                action={
                    <button
                    id='dashboard-inventory-navigate-btn'
                        onClick={navigate} 
                        style={{
                            cursor:'pointer',
                            width: 40,
                            height: 30,
                            background: 'none',
                            borderRadius: 5,
                            border: '1px white solid',
                            float:'right',
                            position: 'relative',
                            top: 5,
                            right: 3
                        }}
                        role='button'
                        aria-label='manage devices'
                    >
                        <FontAwesomeIcon 
                            icon='cog'
                            size='lg'
                            style={{
                                color: 'white'
                            }}
                        />
                    </button>
                }
            />
            <CardContent>
                <Content {...props} />
            </CardContent>
        </Card>
    );
};

//---------------------------------------------------------------------------//
// Export
//---------------------------------------------------------------------------//

export default Component;

//---------------------------------------------------------------------------//
