//---------------------------------------------------------------------------//
// Import
//---------------------------------------------------------------------------//

import React from 'react';
import Grid from '@material-ui/core/Grid';

//---------------------------------------------------------------------------//
// Component
//---------------------------------------------------------------------------//

const Component = (props) => {
    return (
        <Grid 
            container
            direction='row'
            justify='center'
            alignItems='flex-start'
            spacing={3}
        >
            <Grid item xs={6}
                role='text'
                aria-label={"number of QoS scopes: "+props.state.qos.scopeCount}
            >
                <span
                    id='dashboard-qos-count-scope'
                    style={{
                        fontSize: 35,
                        fontWeight: 'bold',
                        color: '#e1c147',
                        display:'block',
                        textAlign: 'center'
                    }}
                >
                    {props.state.qos.scopeCount}
                </span>
                <span
                    style={{
                        display:'block',
                        textAlign: 'center',
                        color:'#495057'
                    }}
                >
                    Scope
                </span>
            </Grid>
            <Grid item xs={6}
                role='text'
                aria-label={"number of QoS policies: "+props.state.dashboard.numApplicationPolicies}
            >
                <span
                    id='dashboard-qos-count-policy'
                    style={{
                        fontSize: 35,
                        fontWeight: 'bold',
                        color: '#e1c147',
                        display:'block',
                        textAlign: 'center'
                    }}
                >
                    {props.state.dashboard.numApplicationPolicies}
                </span>
                <span
                    style={{
                        display:'block',
                        textAlign: 'center',
                        color:'#495057'
                    }}
                >
                    Policy
                </span>
            </Grid>
        </Grid>
    );
};

//---------------------------------------------------------------------------//
// Export
//---------------------------------------------------------------------------//

export default Component;

//---------------------------------------------------------------------------//
