//---------------------------------------------------------------------------//
// Import
//---------------------------------------------------------------------------//

import React from 'react';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import { faGavel, faCog } from '@fortawesome/free-solid-svg-icons';
import { library } from '@fortawesome/fontawesome-svg-core';
import Card from '@material-ui/core/Card';
import CardHeader from '@material-ui/core/CardHeader';
import CardContent from '@material-ui/core/CardContent';
import { useHistory } from 'react-router-dom';
import Content from './Content';

//---------------------------------------------------------------------------//

library.add(faGavel, faCog);

//---------------------------------------------------------------------------//
// Component
//---------------------------------------------------------------------------//

const Component = (props) => {
    let history = useHistory();

    const navigate = () => {
        history.push('qos');
    };

    return (
        <Card
            role='contentinfo'
            aria-label='QoS policies and scopes'
        >
            <CardHeader
                style={{
                    borderBottom: '1px #dde0e6 solid',
                    color:'white',
                    background: '#1e714c',
                }}
                avatar={
                    <FontAwesomeIcon icon='gavel' size='lg' fixedWidth style={{color:'shite'}}/>
                }
                title='Qos'
                action={
                    <button
                        id='dashboard-qos-navigate-btn'
                        onClick={navigate} 
                        style={{
                            cursor:'pointer',
                            width: 40,
                            height: 30,
                            background: 'none',
                            borderRadius: 5,
                            border: '1px white solid',
                            float:'right',
                            position: 'relative',
                            top: 5,
                            right: 3
                        }}
                        role='button'
                        aria-label='manage QoS policies and scopes'
                    >
                        <FontAwesomeIcon 
                            icon='cog'
                            size='lg'
                            style={{
                                color: 'white'
                            }}
                        />
                    </button>
                }
            />
            <CardContent>
                <Content {...props} />
            </CardContent>
        </Card>
    );
};

//---------------------------------------------------------------------------//
// Export
//---------------------------------------------------------------------------//

export default Component;

//---------------------------------------------------------------------------//
