//---------------------------------------------------------------------------//
// Import
//---------------------------------------------------------------------------//

import React from 'react';
import { makeStyles } from '@material-ui/core/styles';
import TextField from '@material-ui/core/TextField';

//---------------------------------------------------------------------------//

const useStyles = makeStyles(theme => ({
    root: {
        overflow: 'visible'
    },
    field: {
        marginRight: 20
    }
}));

const defaultState = {
    name: '',
    ipAddressList: '',
    timeout: '5',
    retry: '3',
    cdpLevel: '16'
};

//---------------------------------------------------------------------------//
// Component
//---------------------------------------------------------------------------//

const Component = (props) => {

    const classes = useStyles();
    const [form, setState] = React.useState(defaultState);

    const handleChange = (event, key) => {
        let settings = { ...form };
        let value = event.target.value;
        settings[key] = value;
        setState(settings);
        props.payloadChange(value, key)
    };
    
    const row = (label, key) => {

        let value = form[key];

        if(value===undefined){
            value= '';
        }

        return(
            <TextField
                id={`discovery-add-cdp-${key}`}
                margin='dense'
                label={label}
                type='text'
                variant="outlined"
                size="small"
                className={classes.field}
                value={value}
                fullWidth
                onChange={event => handleChange(event, key)}
            />
        );
    };

    return (
        <form>
            {row('Name', 'name')}
            {row('IP Address', 'ipAddressList')}
            {row('Timeout', 'timeout')}
            {row('Retry', 'retry')}
            {row('CDP Level', 'cdpLevel')}
        </form>
    );
};

//---------------------------------------------------------------------------//
// Export
//---------------------------------------------------------------------------//

export default Component;

//---------------------------------------------------------------------------//