//---------------------------------------------------------------------------//
// Import
//---------------------------------------------------------------------------//

import React from 'react';
import Grid from '@material-ui/core/Grid';
import { connect } from 'react-redux';
import Login from './components/Login';
import Setup from './components/Setup';
import Loading from '../../components/Loading';
import CommonApi from '../../Api';

//---------------------------------------------------------------------------//
// Component
//---------------------------------------------------------------------------//

const Component = (props) => {
    const getForm = () => {
        if(props.state.setupCompleted === null){
            return <Loading />
        }
        else if(props.state.setupCompleted){
            return <Login {...props} />
        }
        else{
            return <Setup {...props} />
        }
    };

    return (
        <Grid 
            container
            direction='row'
            justify='center'
            alignItems='center'
            style={{
                height: '80vh'
            }}
        >
            {getForm()}
        </Grid>
    );
};

//---------------------------------------------------------------------------//
// Redux Actions
//---------------------------------------------------------------------------//

const mapStateToProps = state => ({
    state: state.app
});

const mapDispatchToProps = dispatch => ({
    dispatchUtil: {
        login: (user, history) => {
            CommonApi.Login.addTicket(dispatch, user, history);
        },
        setup: (user, history) => {
            CommonApi.Login.addSetup(dispatch, user, history);
        }
    }
});

//---------------------------------------------------------------------------//
// Export
//---------------------------------------------------------------------------//

export default connect(
    mapStateToProps,
    mapDispatchToProps
)(Component);

//---------------------------------------------------------------------------//