//---------------------------------------------------------------------------//
// Import
//---------------------------------------------------------------------------//

import React from 'react';
import Grid from '@material-ui/core/Grid';
import Table from '@material-ui/core/Table';
import TableBody from '@material-ui/core/TableBody';
import TableCell from '@material-ui/core/TableCell';
import TableRow from '@material-ui/core/TableRow';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import { faArrowDown } from '@fortawesome/free-solid-svg-icons';
import { library } from '@fortawesome/fontawesome-svg-core';

//---------------------------------------------------------------------------//

library.add(faArrowDown);

//---------------------------------------------------------------------------//
// Component
//---------------------------------------------------------------------------//

const Component = (props) => {

    let ingress = ''
    if(props.ingress !== undefined){
        ingress = props.ingress.physicalInterface.name
    }
    
    let egress = ''
    if(props.egress !== undefined){
        egress = props.egress.physicalInterface.name
    }

    const getArrow = () => {
        if(!props.last){
            return(
                <div
                    style={{
                        color:'#52ae67',
                        marginTop: 8,
                        display: 'block',
                        textAlign:'center'
                    }}
                >
                    <FontAwesomeIcon 
                        icon='arrow-down' 
                        size='2x' 
                    />
                </div>
            );
        }else{
            return null;
        }
    }

    return (
        <Grid 
            container
            direction='row'
            spacing={1}
        >
            <Grid item xs={3}>
                <div
                    style={{
                        display: 'block',
                        textAlign:'center'
                    }}
                >
                    <img
                        style={{
                            maxWidth: 50,
                            maxHeight: 50,
                            marginRight: 10,
                        }}
                        src={`images/${props.image}` }
                        alt='pathtrace img'
                    />
                </div>
                <span
                    id={`pathttrace-detail-name-${props.index}`}
                    style={{
                        fontWeight: 'bold',
                        display: 'block',
                        textAlign: 'center'
                    }}
                >
                    {props.name}
                </span>
                <span
                    id={`pathttrace-detail-type-${props.index}`}
                    style={{
                        display: 'block',
                        textAlign:'center'
                    }}
                >
                    {props.type}
                </span>
                {getArrow()}
            </Grid>
            <Grid item xs={9}>
                <Table style={{
                    marginTop: 10
                }}>
                    <TableBody>
                        <TableRow>
                            <TableCell align='right' size='small' padding={'none'} style={{width:150, fontWeight:'bold'}}>
                                <span
                                    style={{
                                        marginRight:10
                                    }}
                                >
                                    Ip Address
                                </span>
                            </TableCell>
                            <TableCell id={`pathttrace-detail-ip-${props.index}`} align='left' size='small' padding={'none'}>{props.ip}</TableCell>
                        </TableRow>
                        <TableRow>
                            <TableCell align='right' size='small' padding={'none'} style={{width:150, fontWeight:'bold'}}>
                                <span
                                    style={{
                                        marginRight:10
                                    }}
                                >
                                    Ingress Interface
                                </span>    
                            </TableCell>
                            <TableCell id={`pathttrace-detail-ingress-${props.index}`} align='left' size='small' padding={'none'}>{ingress}</TableCell>
                        </TableRow>
                        <TableRow>
                            <TableCell align='right' size='small' padding={'none'} style={{width:150, fontWeight:'bold'}}>
                                <span
                                    style={{
                                        marginRight:10
                                    }}
                                >
                                    Egress Interface
                                </span>     
                            </TableCell>
                            <TableCell id={`pathttrace-detail-egress-${props.index}`} align='left' size='small' padding={'none'}>{egress}</TableCell>
                        </TableRow>
                    </TableBody>
                </Table>
            </Grid>
        </Grid>
    );
};

//---------------------------------------------------------------------------//
// Export
//---------------------------------------------------------------------------//

export default Component;

//---------------------------------------------------------------------------//