//---------------------------------------------------------------------------//
// Import
//---------------------------------------------------------------------------//

import React from 'react';
import Grid from '@material-ui/core/Grid';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import { faCaretRight } from '@fortawesome/free-solid-svg-icons';
import { library } from '@fortawesome/fontawesome-svg-core';

//---------------------------------------------------------------------------//

library.add(faCaretRight);

//---------------------------------------------------------------------------//
// Component
//---------------------------------------------------------------------------//

const Component = (props) => {
    return (
        <Grid 
            container
            direction='row'
            justify='center'
            spacing={1}
            style={{
                color:'#619ed2'
            }}
        >
            <Grid item xs={5}>
                <span
                    id={`pathtrace-list-item-source-${props.index}`}
                >
                    {props.source}
                </span>
            </Grid>
            <Grid item xs={2}>
                <FontAwesomeIcon icon='caret-right' size='1x' fixedWidth />
            </Grid>
            <Grid item xs={5}>
                <span
                    id={`pathtrace-list-item-destination-${props.index}`}
                >
                    {props.destination}
                </span>
            </Grid>
        </Grid>
    );
};

//---------------------------------------------------------------------------//
// Export
//---------------------------------------------------------------------------//

export default Component;

//---------------------------------------------------------------------------//