//---------------------------------------------------------------------------//
// Import
//---------------------------------------------------------------------------//

import React from 'react';
import List from '@material-ui/core/List';
import ListItem from '@material-ui/core/ListItem';
import Item from './Item';
import Grid from '@material-ui/core/Grid';
import _ from 'lodash';

//---------------------------------------------------------------------------//
// Component
//---------------------------------------------------------------------------//

const Component = (props) => {
    
    const click = (item) => {
        props.dispatchUtil.getPathTrace(item.id)
    };

    return (
        <div>
            <Grid 
                container
                direction='row'
                justify='center'
                spacing={1}
            >
                <Grid item xs={5}>
                    <b style={{textAlign:'center'}}>Source</b>
                </Grid>
                <Grid item xs={2}>
                </Grid>
                <Grid item xs={5}>
                    <b style={{textAlign:'center'}}>Destination</b>
                </Grid>
            </Grid> 
            <List>
                {_.map(props.state.list, (row, index) => {
                    let selectedId = ''
                    if(props.state.detail.request){
                        selectedId = props.state.detail.request.id;
                    }
                    return(
                        <ListItem
                            button={true}
                            selected={row.id===selectedId}
                            key={index}
                            onClick={()=>{
                                click(row);
                            }}
                        >
                            <Item 
                                index={index}
                                source={row.sourceIP}
                                destination={row.destIP}
                            />
                        </ListItem>
                    )
                })}
            </List>
        </div>
    );
};

//---------------------------------------------------------------------------//
// Export
//---------------------------------------------------------------------------//

export default Component;

//---------------------------------------------------------------------------//