//---------------------------------------------------------------------------//
// Import
//---------------------------------------------------------------------------//

import React  from 'react';
import { faGavel} from '@fortawesome/free-solid-svg-icons';
import { library } from '@fortawesome/fontawesome-svg-core';
import Card from '@material-ui/core/Card';
import CardHeader from '@material-ui/core/CardHeader';
import CardContent from '@material-ui/core/CardContent';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import Table from './Table';
import Add from './Add';

//---------------------------------------------------------------------------//

library.add(faGavel);

//---------------------------------------------------------------------------//
// Component
//---------------------------------------------------------------------------//

const Component = (props) => {
    
    return (
        <Card>
            <CardHeader
                avatar={
                    <FontAwesomeIcon icon='gavel' size='lg' fixedWidth />
                }
                title='Policy'
                action={
                    <Add {...props} />
                }
                style={{
                    borderBottom: '1px #dde0e6 solid',
                    color: '#495057'
                }}
            />
            <CardContent>
                <Table {...props} />
            </CardContent>
        </Card>
    );
};

//---------------------------------------------------------------------------//
// Export
//---------------------------------------------------------------------------//

export default Component;

//---------------------------------------------------------------------------//