//---------------------------------------------------------------------------//
// Import
//---------------------------------------------------------------------------//

import React from 'react';
import TableCell from '@material-ui/core/TableCell';
import TableRow from '@material-ui/core/TableRow';
import Edit from './Edit';
import _ from 'lodash';

//---------------------------------------------------------------------------//

const deviceList = (devices, key) => {
    let result = [];
    _.forEach(devices, (device, index)=>{
        result.push(
            <span
                key={`device-${index}`}
                style={{
                    display:'block'
                }}
            >
                {device[key]}
            </span>
        );
    })
    return result;
};

//---------------------------------------------------------------------------//
// Component
//---------------------------------------------------------------------------//

const Component = (props) => {
    return (
        <TableRow>
            <TableCell 
                size='small'
                padding='checkbox'
            >
                <Edit {...props} scope={props.item} index={props.index} />
            </TableCell>
            <TableCell id={`qos-scope-table-policyTag-${props.index}`} size='small'>{props.item.policyTag}</TableCell>
            <TableCell id={`qos-scope-table-deviceName-${props.index}`} size='small'>
                {deviceList(props.item.networkDevices, 'deviceName')}
            </TableCell>
            <TableCell id={`qos-scope-table-deviceIp-${props.index}`} size='small'>
                {deviceList(props.item.networkDevices, 'deviceIp')}
            </TableCell>
        </TableRow>
    );
};

//---------------------------------------------------------------------------//
// Export
//---------------------------------------------------------------------------//

export default Component;

//---------------------------------------------------------------------------//
