//---------------------------------------------------------------------------//
// Import
//---------------------------------------------------------------------------//

import React from 'react';
import { faCrosshairs, faPlus } from '@fortawesome/free-solid-svg-icons';
import { library } from '@fortawesome/fontawesome-svg-core';
import Table from '@material-ui/core/Table';
import TableBody from '@material-ui/core/TableBody';
import TableCell from '@material-ui/core/TableCell';
import TableHead from '@material-ui/core/TableHead';
import TableRow from '@material-ui/core/TableRow';
import Card from '@material-ui/core/Card';
import CardHeader from '@material-ui/core/CardHeader';
import CardContent from '@material-ui/core/CardContent';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import _ from 'lodash';
import Row from './Row';
import Add from './Add';

//---------------------------------------------------------------------------//

library.add(faCrosshairs, faPlus);

const Items = (props) => {
    const rows = [];
    _.forEach(props.state.qos.scopes, (item, index) => {
        rows.push(
            <Row
                key={index}
                index={index}
                item={item}
                {...props}
            />
        )
    });
    return rows
};

//---------------------------------------------------------------------------//
// Component
//---------------------------------------------------------------------------//

const Component = (props) => {
    return (
        <Card>
            <CardHeader
                avatar={
                    <FontAwesomeIcon icon='crosshairs' size='lg' fixedWidth />
                }
                title='Scope'
                action={
                    <div>
                        <Add {...props} />
                    </div>
                }
                style={{
                    borderBottom: '1px #dde0e6 solid',
                    color: '#495057'
                }}
            />
            <CardContent>
                    <Table style={{overflow:'auto'}}>
                        <TableHead>
                            <TableRow>
                                <TableCell></TableCell>
                                <TableCell style={{fontWeight:'bold', whiteSpace:'nowrap'}}>Scope Name</TableCell>
                                <TableCell style={{fontWeight:'bold', whiteSpace:'nowrap'}}>Device Name</TableCell>
                                <TableCell style={{fontWeight:'bold', whiteSpace:'nowrap'}}>Device IP</TableCell>
                            </TableRow>
                        </TableHead>
                        <TableBody>
                            { <Items {...props}/> }
                        </TableBody>
                    </Table>
            </CardContent>
        </Card>
    );
};

//---------------------------------------------------------------------------//
// Export
//---------------------------------------------------------------------------//

export default Component;

//---------------------------------------------------------------------------//
