//---------------------------------------------------------------------------//
// Import
//---------------------------------------------------------------------------//

import React from 'react';
import TextField from '@material-ui/core/TextField';
import Save from './Save';

//---------------------------------------------------------------------------//
// Component
//---------------------------------------------------------------------------//

const Component = (props) => {

    const [payload, setPayload] = React.useState(props.settings.aaa);

    const handleChange = (event, props, key) => {
        let newState = {...payload};
        newState[key] = event.target.value;
        setPayload(newState)
    };

    return (
        <>
            <form>
                <div>
                    <TextField 
                        id='setting-authorization-ipAddress' 
                        label='Ip Address' 
                        fullWidth
                        value={payload.ipAddress}
                        style={{marginBottom: 10}}
                        onChange={event => handleChange(event, props, 'ipAddress')}
                    />
                </div>
                <div>
                    <TextField 
                        id='setting-authorization-key' 
                        label='Key' 
                        fullWidth
                        value={payload.key}
                        style={{marginBottom: 10}}
                        onChange={event => handleChange(event, props, 'key')}
                    />
                </div>
            </form>
            <Save {...props} payload={{aaa: payload}}/>
        </>
    );
};

//---------------------------------------------------------------------------//
// Export
//---------------------------------------------------------------------------//

export default Component;

//---------------------------------------------------------------------------//