//---------------------------------------------------------------------------//
// Import
//---------------------------------------------------------------------------//

import React from 'react';
import TextField from '@material-ui/core/TextField';
import Save from './Save';

//---------------------------------------------------------------------------//
// Component
//---------------------------------------------------------------------------//

const Component = (props) => {

    const [payload, setPayload] = React.useState(props.settings.netflow);

    const handleChange = (event, props, key) => {
        let newState = {...payload};
        newState[key] = event.target.value;
        setPayload(newState)
    };

    return (
        <>
            <form>
                <div>
                    <TextField 
                        id='setting-netflow-destinationIp' 
                        label='Reflection Ip'
                        fullWidth
                        value={payload.reflectionIp}
                        style={{marginBottom: 10}}
                        onChange={event => handleChange(event, props, 'reflectionIp')}
                    />
                </div>
                <div>
                    <TextField 
                        id='setting-netflow-portNumber' 
                        label='Port Number' 
                        fullWidth
                        value={payload.port}
                        style={{marginBottom: 10}}
                        onChange={event => handleChange(event, props, 'port')}
                    />
                </div>
            </form>
            <Save {...props} payload={{netflow: payload}}/>
        </>
    );
};

//---------------------------------------------------------------------------//
// Export
//---------------------------------------------------------------------------//

export default Component;

//---------------------------------------------------------------------------//