//---------------------------------------------------------------------------//
// Import
//---------------------------------------------------------------------------//

import React from 'react';
import TextField from '@material-ui/core/TextField';
import Save from './Save';

//---------------------------------------------------------------------------//
// Component
//---------------------------------------------------------------------------//

const Component = (props) => {

    const [payload, setPayload] = React.useState(props.settings.ntp);

    const handleChange = (event, props, key) => {
        let newState = {...payload};
        newState[key] = event.target.value;
        setPayload(newState)
    };

    return (
        <>
            <form>
                <div>
                    <TextField 
                        id='setting-ntp-serverip' 
                        label='Server Ip' 
                        fullWidth
                        value={payload.serverIp}
                        style={{marginBottom: 10}}
                        onChange={event => handleChange(event, props, 'serverIp')}
                    />
                </div>
            </form>
            <Save {...props} payload={{ntp: payload}}/>
        </>
    );
};

//---------------------------------------------------------------------------//
// Export
//---------------------------------------------------------------------------//

export default Component;

//---------------------------------------------------------------------------//