//---------------------------------------------------------------------------//
// Import
//---------------------------------------------------------------------------//

import React from 'react';
import Button from '@material-ui/core/Button';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import { faSave } from '@fortawesome/free-solid-svg-icons';
import { library } from '@fortawesome/fontawesome-svg-core';

//---------------------------------------------------------------------------//

library.add(faSave);

//---------------------------------------------------------------------------//
// Component
//---------------------------------------------------------------------------//

const Component = (props) => {

    const click = () =>{
        props.dispatchUtil.edit(props.payload);
    };

    return (
        <Button 
            id='setting-submit'
            onClick={click} 
            variant='contained' 
            color='primary' 
            style={{
                float:'right', 
                marginTop: 20,
                marginRight:20
            }}
        >
            <FontAwesomeIcon icon='save' size='1x' fixedWidth />
            <span
                style={{
                    marginLeft: 5
                }}
            >
                Save
            </span>
        </Button>
    );
};

//---------------------------------------------------------------------------//
// Export
//---------------------------------------------------------------------------//

export default Component;

//---------------------------------------------------------------------------//