//---------------------------------------------------------------------------//
// Import
//---------------------------------------------------------------------------//

import React from 'react';
import Table from '@material-ui/core/Table';
import TableBody from '@material-ui/core/TableBody';
import TableCell from '@material-ui/core/TableCell';
import TableHead from '@material-ui/core/TableHead';
import TableRow from '@material-ui/core/TableRow';
import _ from 'lodash';
import { makeStyles } from '@material-ui/core/styles';

//---------------------------------------------------------------------------//

const useStyles = makeStyles({
    table: {
        //minWidth: 650,
    },
});

const Items = (props) => {
    const rows = [];
    _.forEach(props.items, (item, key) => {
        rows.push(
            <TableRow 
                key={key}
                hover={true}
            >
                <TableCell id={`user-users-username-${key}`} align='center' size='small'>{item.username}</TableCell>
                <TableCell id={`user-users-role-${key}`} align='center' size='small'>{item.authorization[0].role}</TableCell>
            </TableRow>
        )
    });
    return rows
};

//---------------------------------------------------------------------------//
// Component
//---------------------------------------------------------------------------//

const Component = (props) => {
    const classes = useStyles();
    return (
        <Table className={classes.table} aria-label='simple table'>
            <TableHead>
                <TableRow>
                    <TableCell align='center' size='small' style={{ fontWeight: 'bold' }}>Username</TableCell>
                    <TableCell align='center' size='small' style={{ fontWeight: 'bold' }}>Role</TableCell>
                </TableRow>
            </TableHead>
            <TableBody>
                { <Items items={props.state.users} dispatchUtil={props.dispatchUtil}/> }
            </TableBody>
        </Table>
    );
};

//---------------------------------------------------------------------------//
// Export
//---------------------------------------------------------------------------//

export default Component;

//---------------------------------------------------------------------------//